<?php
/*
 * Created on 08.08.2009
 * vs. 0.3
 * Copyright: Mariano Alcántara Francia - Boolean Core - http://www.booleancore.com
 * http://www.booleancore.com/bcoregrid/index.php
 * GNU LESSER GENERAL PUBLIC LICENSE
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class BCoreGridWidget extends CWidget
{
  	public $css = "bcgrid";
  	public $row_even = "bcgrid_even";
  	public $row_odd = "bcgrid_odd";
  	public $row_over = "bcgrid_over";
	public $models;
	public $attributes;
	public $pages;
	public $sort;
	public $row_id="id";
	public $row_active=true;
	public $row_actionclick;
	public $row_controller;
	public $row_owner;
	public $isMultiple=true;
	public $cssFile = 'bcoregrid.css';
	public $alert_reg = 'You must select at least one record.';
	public $alert_del = 'Are you sure you want to delete to ';
	public $alert_pub = 'Are you sure you want to publish to ';
	public $alert_unpub = 'Are you sure you want to unpublish to ';
	public $alert_pro = 'Are you sure you want to proceed ?';
	public $url_del;
	public $url_pub;
	public $url_unpub;
	public $idgrid="bcoregrid";

	public function init()
    {
		$this->cssFile=Yii::app()->getAssetManager()->publish(dirname(__FILE__).DIRECTORY_SEPARATOR.$this->cssFile);
	 	$cs=Yii::app()->clientScript;
		$cs->registerCoreScript('jquery');
        $cs->registerCssFile($this->cssFile);
		$this->url_del='?r='.$this->row_controller.'/multidelete';
		$this->url_pub='?r='.$this->row_controller.'/multipublish';
		$this->url_unpub='?r='.$this->row_controller.'/multiunpublish';
		$reg='reg'.$this->idgrid;
		$btndel=$this->idgrid."del";
		$btnpub=$this->idgrid."pub";
		$btnunpub=$this->idgrid."unpub";
		$tclic='t'.$this->idgrid."_";
		$chk_true=$this->idgrid."chk_true";
		$js=<<<EOD
jQuery('#multi').click(function() {
	if (this.checked){ 	jQuery("input[name='cid[]']").each(function() {	this.checked=true;	$("$chk_true").val($("$chk_true").val()+1); });
	} 	else {	jQuery("input[name='cid[]']").each(function() {	this.checked=false;	$("$chk_true").val($("$chk_true").val()-1);	});
	}
});

jQuery("input[name='cid[]']").click(function() {
		if (this.checked){  $("$chk_true").val($("$chk_true").val()+1); }	else {	$("$chk_true").val($("$chk_true").val()-1);	}
});

$('.$this->css tr:even').addClass('bcgrid_even');
$('.$this->css tr').mouseover(function() { $(this).addClass("bcgrid_over"); }).mouseout(function() { $(this).removeClass("bcgrid_over"); });

jQuery("#$btndel").click(function() {
var f=$("#$this->idgrid");
if($("$chk_true").val()==0){ alert('$this->alert_reg'); return; }
var resp=window.confirm('$this->alert_pro');
if (resp)  {  f.attr('action','$this->url_del');  f.submit(); }	
});
jQuery("#$btnpub").click(function() {
var f=$("#$this->idgrid");
if($("$chk_true").val()==0){ alert('$this->alert_reg'); return; }
var resp=window.confirm('$this->alert_pro');
if (resp)  {  f.attr('action','$this->url_pub');  f.submit(); }	
});
jQuery("#$btnunpub").click(function() {
var f=$("#$this->idgrid");
if($("$chk_true").val()==0){ alert('$this->alert_reg'); return; }
var resp=window.confirm('$this->alert_pro');
if (resp)  {  f.attr('action','$this->url_unpub');  f.submit(); }	
});

EOD;
$cs->registerScript("multi",$js);
if($this->row_active) { 
$js2=<<<EOD
 jQuery(".bcgrid td").click(function() {
 if(this.title!="mark") {
 var fid=this.id;
 fid= fid.split("$tclic"); 
 window.location='?r=$this->row_controller/$this->row_actionclick&id='+fid[1];
 }
});
EOD;
$cs->registerScript("multi2",$js2);

}
}

	public function run()
	{
	
	   $this->render('list',array(
	   			"models"=>$this->models,
				"css"=>$this->css,
				"id"=>$this->row_id,
				"idgrid"=>$this->idgrid,
				"isMultiple"=>$this->isMultiple,
				"alert_reg"=>Yii::t('yii',$this->alert_reg),
				"alert_del"=>Yii::t('yii',$this->alert_del),
				"alert_pub"=>Yii::t('yii',$this->alert_pub),
				"alert_unpub"=>Yii::t('yii',$this->alert_unpub),
				"alert_pro"=>Yii::t('yii',$this->alert_pro),
				"url_del"=>$this->url_del,
				"url_pub"=>$this->url_pub,
				"url_unpub"=>$this->url_unpub,
				"row_owner"=>$this->row_owner,
				"row_even"=>$this->row_even,
				"row_odd"=>$this->row_odd,
				"row_over"=>$this->row_over,
				"row_active"=>$this->row_active,
				"row_actionclick"=>$this->row_actionclick,
				"row_controller"=>$this->row_controller,
				"attributes"=>$this->attributes,
				"pages"=>$this->pages,
				"sort"=>$this->sort) 
			) ;
	}
}